diff --git a/jerry-core/api/jerry.c b/jerry-core/api/jerry.c
index 068a07603b..9f60c39ec3 100644
--- a/jerry-core/api/jerry.c
+++ b/jerry-core/api/jerry.c
@@ -3058,6 +3058,7 @@ jerry_foreach_object_property (const jerry_value_t obj_val, /**< object value */
   }
 
   ecma_free_value (JERRY_CONTEXT (error_value));
+  JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
   return false;
 } /* jerry_foreach_object_property */
 
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c b/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c
index 23e7c249ec..9d07c7b840 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c
@@ -611,6 +611,7 @@ ecma_builtin_promise_race_or_all (ecma_value_t this_arg, /**< 'this' argument */
   if (ECMA_IS_VALUE_ERROR (ret))
   {
     ret = JERRY_CONTEXT (error_value);
+    JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
   }
 
   ecma_free_value (capability);
diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-reflect.c b/jerry-core/ecma/builtin-objects/ecma-builtin-reflect.c
index 578bb253ab..00841cd012 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-reflect.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-reflect.c
@@ -93,7 +93,15 @@ ecma_builtin_reflect_dispatch_routine (uint16_t builtin_routine_id, /**< built-i
       ecma_value_t result = ecma_builtin_object_object_set_prototype_of (arguments_list[0], arguments_list[1]);
       bool is_error = ECMA_IS_VALUE_ERROR (result);
 
-      ecma_free_value (is_error ? JERRY_CONTEXT (error_value) : result);
+      if (is_error)
+      {
+        ecma_free_value (JERRY_CONTEXT (error_value));
+        JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
+      }
+      else
+      {
+        ecma_free_value (result);
+      }
 
       return ecma_make_boolean_value (!is_error);
     }
@@ -121,7 +129,15 @@ ecma_builtin_reflect_dispatch_routine (uint16_t builtin_routine_id, /**< built-i
       ecma_deref_ecma_string (name_str_p);
       bool is_error = ECMA_IS_VALUE_ERROR (result);
 
-      ecma_free_value (is_error ? JERRY_CONTEXT (error_value) : result);
+      if (is_error)
+      {
+        ecma_free_value (JERRY_CONTEXT (error_value));
+        JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
+      }
+      else
+      {
+        ecma_free_value (result);
+      }
 
       return ecma_make_boolean_value (!is_error);
     }
diff --git a/jerry-core/ecma/operations/ecma-objects.c b/jerry-core/ecma/operations/ecma-objects.c
index 9205ee9c37..758dec23d2 100644
--- a/jerry-core/ecma/operations/ecma-objects.c
+++ b/jerry-core/ecma/operations/ecma-objects.c
@@ -1233,6 +1233,7 @@ ecma_op_object_put (ecma_object_t *object_p, /**< the object */
           if (ECMA_IS_VALUE_ERROR (error))
           {
             ecma_free_value (JERRY_CONTEXT (error_value));
+            JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
             return ecma_reject (is_throw);
           }
 
diff --git a/jerry-core/ecma/operations/ecma-typedarray-object.c b/jerry-core/ecma/operations/ecma-typedarray-object.c
index befb59691b..833cc975ab 100644
--- a/jerry-core/ecma/operations/ecma-typedarray-object.c
+++ b/jerry-core/ecma/operations/ecma-typedarray-object.c
@@ -1130,6 +1130,7 @@ ecma_op_typedarray_define_index_prop (ecma_object_t *obj_p, /**< a TypedArray ob
     if (ECMA_IS_VALUE_ERROR (error))
     {
       ecma_free_value (JERRY_CONTEXT (error_value));
+      JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
       return false;
     }
     ecma_typedarray_info_t info = ecma_typedarray_get_info (obj_p);
diff --git a/jerry-core/parser/js/js-lexer.c b/jerry-core/parser/js/js-lexer.c
index e3b09ac697..4e106bf96a 100644
--- a/jerry-core/parser/js/js-lexer.c
+++ b/jerry-core/parser/js/js-lexer.c
@@ -2398,16 +2398,15 @@ lexer_construct_regexp_object (parser_context_t *context_p, /**< context */
                                           current_flags);
   ecma_deref_ecma_string (pattern_str_p);
 
-  bool is_throw = ECMA_IS_VALUE_ERROR (completion_value) != 0;
-
-  ecma_free_value (completion_value);
-
-  if (is_throw)
+  if (ECMA_IS_VALUE_ERROR (completion_value))
   {
     ecma_free_value (JERRY_CONTEXT (error_value));
+    JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
     parser_raise_error (context_p, PARSER_ERR_INVALID_REGEXP);
   }
 
+  ecma_free_value (completion_value);
+
   literal_p->type = LEXER_REGEXP_LITERAL;
   literal_p->u.bytecode_p = (ecma_compiled_code_t *) re_bytecode_p;
 
diff --git a/jerry-core/parser/regexp/re-parser.c b/jerry-core/parser/regexp/re-parser.c
index 32a2fd2a22..e0a803079e 100644
--- a/jerry-core/parser/regexp/re-parser.c
+++ b/jerry-core/parser/regexp/re-parser.c
@@ -657,6 +657,7 @@ re_parse_next_token (re_parser_ctx_t *parser_ctx_p, /**< RegExp parser context *
 
       JERRY_ASSERT (ECMA_IS_VALUE_ERROR (ret_value));
       ecma_free_value (JERRY_CONTEXT (error_value));
+      JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
 
       parser_ctx_p->input_curr_p = input_curr_p;
       /* It was not an iterator, continue the parsing. */
@@ -683,6 +684,7 @@ re_parse_next_token (re_parser_ctx_t *parser_ctx_p, /**< RegExp parser context *
       if (!ecma_is_value_empty (ret_value))
       {
         ecma_free_value (JERRY_CONTEXT (error_value));
+        JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
         parser_ctx_p->input_curr_p = input_curr_p;
         ret_value = ECMA_VALUE_EMPTY;
       }
diff --git a/jerry-core/vm/opcodes.c b/jerry-core/vm/opcodes.c
index fdd9fc4c66..d566c2f921 100644
--- a/jerry-core/vm/opcodes.c
+++ b/jerry-core/vm/opcodes.c
@@ -85,6 +85,7 @@ vm_set_var (ecma_object_t *lex_env_p, /**< target lexical environment */
   if (ECMA_IS_VALUE_ERROR (put_value_result))
   {
     ecma_free_value (JERRY_CONTEXT (error_value));
+    JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
   }
 
   ecma_free_value (lit_value);
diff --git a/jerry-core/vm/vm.c b/jerry-core/vm/vm.c
index ae70ab5c70..662ac8f719 100644
--- a/jerry-core/vm/vm.c
+++ b/jerry-core/vm/vm.c
@@ -1629,6 +1629,7 @@ vm_loop (vm_frame_ctx_t *frame_ctx_p) /**< frame context */
               if (ECMA_IS_VALUE_ERROR (result))
               {
                 ecma_free_value (JERRY_CONTEXT (error_value));
+                JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
               }
 
               ecma_free_value (result);
diff --git a/tests/jerry/es2015/regression-test-issue-3422.js b/tests/jerry/es2015/regression-test-issue-3422.js
new file mode 100644
index 0000000000..da552266cd
--- /dev/null
+++ b/tests/jerry/es2015/regression-test-issue-3422.js
@@ -0,0 +1,21 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+try {
+  RegExp('{}');
+  let {t: []} = {t: []}
+  assert(false);
+} catch (e) {
+  assert (e instanceof SyntaxError);
+}
diff --git a/tests/unit-core/test-to-integer.c b/tests/unit-core/test-to-integer.c
index 191e0d53e9..fc94c5838d 100644
--- a/tests/unit-core/test-to-integer.c
+++ b/tests/unit-core/test-to-integer.c
@@ -52,6 +52,7 @@ main (void)
   result = ecma_op_to_integer (error, &num);
 
   ecma_free_value (JERRY_CONTEXT (error_value));
+  JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
 
   TEST_ASSERT (ECMA_IS_VALUE_ERROR (result));
 
diff --git a/tests/unit-core/test-to-length.c b/tests/unit-core/test-to-length.c
index 4c6c2976c9..029a47cf90 100644
--- a/tests/unit-core/test-to-length.c
+++ b/tests/unit-core/test-to-length.c
@@ -52,6 +52,7 @@ main (void)
   result = ecma_op_to_length (error_throw, &num);
 
   ecma_free_value (JERRY_CONTEXT (error_value));
+  JERRY_CONTEXT (status_flags) &= (uint32_t) ~ECMA_STATUS_EXCEPTION;
 
   TEST_ASSERT (ECMA_IS_VALUE_ERROR (result));
 
